/***************************************************************************
 *   Copyright (C) 2005 by Jaymin Kessler                                  *
 *   root@localhost.localdomain                                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef _DJR_FRAMEMEMMNGR_H_
#define _DJR_FRAMEMEMMNGR_H_

#include "UsefulMacros.h"

// TODO: see if this is really the best way to do this on the PS2
// its uberslow so dont call it in a loop or anything stupid like that!

#define ALIGN_MEMORY( Address__, Alignment__, Cast__ ) ( (int)Address__ % Alignment__ == 0? Address__ : (Cast__)( (int)Address__ + Alignment__ - ( (int)Address__ % Alignment__ ) ) )

enum{ STACK_PTR_LOWER, STACK_PTR_UPPER };  

// explanation: I wrote this on my AMD64 linux box which had a nice implementation of memalign()
// and posix_memalign().  PS2Linux doesnt have these so I added pAddrToFree to keep track of the
// pointer malloc returned.  pPermanentMemPtr now points to the manually aligned memory so the system
// can function like it did before without significant code changes.  JUST REMEMBER TO FREE
// pAddrToFree AND __NOT__ pPermanentMemPtr!!!  
typedef struct
{
  void *pAddrToFree;
  void *pPermanentMemPtr;  // DO NOT CHANGE AFTER ALLOCATING!  used to free all memory when killed
  void *pStackPtr[2];         
}MemStack;

typedef enum
{
  STACKTYPE_T1,  // memory for turntable 1
  STACKTYPE_T2,  // memory for turntable 2
  STACKTYPE_NUMTYPES
}StackType;

void FrameMemMngrInit( void );
void FrameMemMngrKill( void );
void FrameMemMngrResetAllPointers( int iStack );
Bool FrameMemMngrCreate( int iNumBytes, int iAlignment  );
void FrameMemMngrDestroy( void );
void *FrameMemMngrAllocate( StackType type, Bool bUpper, int iNumBytes );
void *FrameMemMngrObtainFrame( StackType type, Bool bUpper );
Bool FrameMemMngrDeallocateFrame( StackType type, Bool bUpper, void *pFrame);
void FrameMemMngrDeallocateAll( StackType type, Bool bUpper );

#endif
