#ifndef _DJR_MODEL_H_
#define _DJR_MODEL_H_

#include <stdio.h>
#include "sps2lib.h"
#include "UsefulMacros.h"

typedef enum
{
  MODEL_DMATAG,
  MODEL_GIFTAG,
}eModelTag;

typedef struct
{
  Bool m_bLoaded;
  int m_iNumPages;
  int m_iTexSlot;
  int m_iSPS2Descriptor;
  sps2Memory_t **m_pDMAChainPages;
}StaticModel_t;

void InitModel( StaticModel_t *pModel, int iSPS2Descriptor );
Bool LoadDMAFile( StaticModel_t *pModel, char *sFileName, 
                  int iTexSlot, char *pLogFile );
void DumpModel( StaticModel_t *pModel );
void SetTextureSlot( StaticModel_t *pModel, int iTexSlot );
void RenderModel( StaticModel_t *pModel );
Bool LogModelTag( FILE *fp, eModelTag tag, 
                  void *pTagAddr, sps2Memory_t *pPage );

#endif
