#include <stdio.h>
#include <string.h>
#include "DJR_PadManager.h"

// defines

// pay attention to the lower 32 bits of the button bitmap
#define BUTTON_BITMAP_SIZE 16

//statics
static unsigned char _iButtonPresses[ PS2PAD_NUM_PRESSURE_BUTTONS ];
static unsigned long _iButtonBits;
static unsigned long _iButtonTimes[ BUTTON_BITMAP_SIZE ];
static float _fSticks[ 2 ][ 2 ];
static float _fSticksPrev[ 2 ][ 2 ];

/**********************************************************************/
void PadInit( void )
{
    int iSuccess;
    printf( "\n\ninitializing joypadlib... " );
    iSuccess = joypadlib_initialize( );
    printf( "%s", iSuccess? "success" : "failed" );
    memset( _iButtonPresses, 0 , PS2PAD_NUM_PRESSURE_BUTTONS );
    _iButtonBits = 0;
    memset( _fSticks, 0, sizeof( float ) * 4 );
    memset( _fSticksPrev, 0, sizeof( float ) * 4 );
    memset( _iButtonTimes, 0, sizeof( long ) * BUTTON_BITMAP_SIZE );
}

/**********************************************************************/
void PadShutdown( void )
{
    printf( "\n\nshutting down joypadlib... " );
    fflush( NULL );
    joypadlib_shutdown( );
    printf( " done." );
    fflush( NULL );
}

/**********************************************************************/
void PadUpdatePadData( void )
{
    int iBitCnt;
    joypadlib_update( );
    _iButtonBits = joypadlib_get_joypad_buttons( 0, _iButtonPresses, 
                                                 PRESSURE_TYPE_BYTE );

    // always store off the prev value for velocity and accel
    memcpy( _fSticksPrev, _fSticks, sizeof( float ) * 4 );

    joypadlib_get_joypad_sticks( 0, _fSticks[ 0 ], _fSticks[ 1 ] );

    // caconical IOP printf hack!!!
    //printf( "canonical IOP hack here! " );

    // how long has the button been held down for???
    for( iBitCnt = 0; iBitCnt < BUTTON_BITMAP_SIZE; iBitCnt++ )
    {
      //_iButtonTimes[ iBitCnt ] = _iButtonBits & ( 1 << iBitCnt )? 
      //    _iButtonTimes[ iBitCnt ] + 1 : 0;
      if( _iButtonBits & ( 1 << iBitCnt ) )
      {
        _iButtonTimes[ iBitCnt ]++;
        //printf( "\n\nPadUpdate: button %d held down for %ld", 
        //  ( 1 << iBitCnt ), _iButtonTimes[ iBitCnt ] );
      } 
      else
      {
        _iButtonTimes[ iBitCnt ] = 0;
      }
    }    
}

/**********************************************************************/
unsigned long PadIsButtonPressed( int iPad, unsigned int iButton )
{
  if( _iButtonBits & iButton )
  {
      int iLog2 = 0;
      for( iLog2 = 0; iLog2 < BUTTON_BITMAP_SIZE; iLog2++ )
      {
        if( 1 << iLog2 == iButton )
          break;
      }

      // an invalid button was passed in
      if( iLog2 >= BUTTON_BITMAP_SIZE )
        return 0;

      //printf( "\n\nbutton %d held down for %ld count", 
      //  iButton, _iButtonTimes[ iLog2 ] );
      return _iButtonTimes[ iLog2 ];
  }
  else
  {
      return 0;
  }  
}

/**********************************************************************/
void PadGetAnalogSticks( int iPad, int iRight, 
                         float *fX, float *fY, float *fVelY )
{
  if( fX )
    *fX = _fSticks[ iRight ][ 0 ];

  if( fY )
    *fY = _fSticks[ iRight ][ 1 ];

  if( fVelY )
    *fVelY = _fSticks[ iRight ][ 1 ] - _fSticksPrev[ iRight ] [ 1 ];
}

/**********************************************************************/

/**********************************************************************/
