#ifndef __GSREGS_H__
#define __GSREGS_H__

#include <sps2types.h>

#define TRXDIR_EE_TO_GS ((sps2uint64)(0))

// register addresses
#define BITBLTBUF_R (sps2uint64)0x50
#define TRXPOS_R (sps2uint64)0x51
#define TRXREG_R (sps2uint64)0x52
#define TRXDIR_R (sps2uint64)0x53
#define TEXFLUSH_R (sps2uint64)0x3F
#define TEX0_1_R (sps2uint64)0x06
#define PRIM_R (sps2uint64)0x00
#define UV_R (sps2uint64)0x03
#define ST_R (sps2uint64)0x02
#define XYZ2_R (sps2uint64)0x05
#define RGBAQ_R (sps2uint64)0x01
#define ALPHA_1_R (sps2uint64)0x42

// macros for packing 64 bit A_D registers

#define PACK_BITBLTBUF(SBP,SBW,SPSM,DBP,DBW,DPSM)  (((sps2uint64)(SBP) << 0) | ((sps2uint64)(SBW) << 16) | ((sps2uint64)(SPSM) << 24) | ((sps2uint64)(DBP) << 32) | ((sps2uint64)(DBW) << 48) |((sps2uint64)(DPSM) << 46))  

#define PACK_TRXPOS(SSAX,SSAY,DSAX,DSAY,DIR)  (((sps2uint64)(SSAX) << 0) | ((sps2uint64)(SSAY) << 16) | ((sps2uint64)(DSAX) << 32) | ((sps2uint64)(DSAY) << 48) | ((sps2uint64)(DIR) << 59))

#define PACK_TRXREG(RRW,RRH)  (((sps2uint64)(RRW) << 0) | ((sps2uint64)(RRH) << 32))

#define PACK_TEX0(TBP0,TBW,PSM,TW,TH,TCC,TFX,CBP,CPSM,CSM,CSA,CLD)  (((sps2uint64)(TBP0)<< 0)  | ((sps2uint64)(TBW) << 14) | ((sps2uint64)(PSM) << 20) | ((sps2uint64)(TW)  << 26) | ((sps2uint64)(TH)  << 30) | ((sps2uint64)(TCC) << 34) | ((sps2uint64)(TFX) << 35) | ((sps2uint64)(CBP) << 37) | ((sps2uint64)(CPSM)<< 51) | ((sps2uint64)(CSM) << 55) | ((sps2uint64)(CSA) << 56) | ((sps2uint64)(CLD) << 61))

#define PACK_PRIM(PRI,IIP,TME,FGE,ABE,AA1,FST,CTXT,FIX)  (((sps2uint64)(PRI) << 0) | ((sps2uint64)(IIP) << 3) | ((sps2uint64)(TME) << 4) | ((sps2uint64)(FGE) << 5) | ((sps2uint64)(ABE) << 6) | ((sps2uint64)(AA1) << 7) | ((sps2uint64)(FST) << 8) | ((sps2uint64)(CTXT)<< 9) | ((sps2uint64)(FIX) << 10))

#define PACK_UV(U,V) (((sps2uint64)(U) << 0) | ((sps2uint64)(V) << 16))

#define PACK_ST(S,T) (((sps2uint64)(S) << 0) | ((sps2uint64)(T) << 32))

#define PACK_RGBAQ(R,G,B,A,Q) (((sps2uint64)(R) << 0) | ((sps2uint64)(G) << 8) | ((sps2uint64)(B) << 16) | ((sps2uint64)(A) << 24) | ((sps2uint64)(Q) << 32))

#define PACK_XYZ2(X,Y,Z) (((sps2uint64)(X) << 0) | ((sps2uint64)(Y) << 16) | ((sps2uint64)(Z) << 32))

#define PACK_ALPHA_1(A,B,C,D,FIX) (((sps2uint64)(A) << 0) | ((sps2uint64)(B) << 2) | ((sps2uint64)(C) << 4) | ((sps2uint64)(D) << 6) | ((sps2uint64)(FIX) << 32))

#endif
